Blockly.JavaScript['vec_const'] = function(block) {
  var text_x = block.getFieldValue('x');
  var text_y = block.getFieldValue('y');
  var code = 'Vector.create([' + text_x + ',' + text_y + '])';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['vec_3D'] = function(block) {
  var text_x = block.getFieldValue('x');
  var text_y = block.getFieldValue('y');
  var text_z = block.getFieldValue('z');
  var code = 'Vector.create([' + text_x + ',' + text_y + ',' + text_z + '])';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['vec_alea'] = function(block) {
  var code = 'Vector.Random(2)';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['vec_alea3'] = function(block) {
  var code = 'Vector.Random(3)';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['vec_nul'] = function(block) {
  var code = 'Vector.Zero(2)';
  return [code, Blockly.JavaScript.ORDER_NONE];
};
Blockly.JavaScript['vec_nul3'] = function(block) {
  var code = 'Vector.Zero(3)';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['vec_aff'] = function(block) {
  var value_vec = Blockly.JavaScript.valueToCode(block, 'vec', Blockly.JavaScript.ORDER_ATOMIC);
  var code = value_vec + '.inspect()';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['vec_eq'] = function(block) {
  var variable_lui = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('lui'), Blockly.Variables.NAME_TYPE);
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_lui + '.eql(' + value_autre + ')';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['vec_add'] = function(block) {
  var variable_lui = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('lui'), Blockly.Variables.NAME_TYPE);
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_lui + '.add(' + value_autre + ')';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['vec_sub'] = function(block) {
  var variable_lui = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('lui'), Blockly.Variables.NAME_TYPE);
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_lui + '.subtract(' + value_autre + ')';
  return [code, Blockly.JavaScript.ORDER_NONE];
};


Blockly.JavaScript['vec_dot'] = function(block) {
  var variable_lui = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('lui'), Blockly.Variables.NAME_TYPE);
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_lui + '.dot(' + value_autre + ')';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['vec_angle'] = function(block) {
  var variable_lui = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('lui'), Blockly.Variables.NAME_TYPE);
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_lui + '.angleFrom(' + value_autre + ')';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['vec_distance'] = function(block) {
  var variable_lui = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('lui'), Blockly.Variables.NAME_TYPE);
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_lui + '.distanceFrom(' + value_autre + ')';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['vec_abscisse'] = function(block) {
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = value_autre + '.e(1)';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['vec_ordonnee'] = function(block) {
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = value_autre + '.e(2)';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['vec_colineaire'] = function(block) {
  var variable_lui = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('lui'), Blockly.Variables.NAME_TYPE);
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = '(' + variable_lui + '.isAntiparallelTo(' + value_autre + ')) || (' + variable_lui + '.isParallelTo(' + value_autre + '))';
  return [code, Blockly.JavaScript.ORDER_NONE];
};



Blockly.JavaScript['vec_perpendiculaire'] = function(block) {
  var variable_lui = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('lui'), Blockly.Variables.NAME_TYPE);
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_lui + '.isPerpendicularTo(' + value_autre + ')';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['vec_fois'] = function(block) {
  var variable_lui = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('lui'), Blockly.Variables.NAME_TYPE);
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_lui + '.multiply(' + value_autre + ')';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['vec_foisbis'] = function(block) {
  var text_facteur = block.getFieldValue('facteur');
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = value_autre + '.multiply(' + text_facteur + ')';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['vec_symmetry'] = function(block) {
  var variable_lui = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('lui'), Blockly.Variables.NAME_TYPE);
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_lui + '.reflectionIn(' + value_autre + ')';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['vec_rotation'] = function(block) {
  var variable_lui = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('lui'), Blockly.Variables.NAME_TYPE);
  var text_angle = block.getFieldValue('angle');
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_lui + '.rotate(' + text_angle + ',' + value_autre + ')';
  return [code, Blockly.JavaScript.ORDER_NONE];
};


Blockly.JavaScript['vec_norme'] = function(block) {
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = value_autre + '.modulus()';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['vec_unitaire'] = function(block) {
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = value_autre + '.toUnitVector()';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['vec_diagonal'] = function(block) {
  var value_vecteur = Blockly.JavaScript.valueToCode(block, 'vecteur', Blockly.JavaScript.ORDER_ATOMIC);
  var code = value_vecteur + '.toDiagonalMatrix()';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['mat_matrice'] = function(block) {
  var text_a11 = block.getFieldValue('a11');
  var text_a12 = block.getFieldValue('a12');
  var text_a21 = block.getFieldValue('a21');
  var text_a22 = block.getFieldValue('a22');
  var code = 'Matrix.create([['+text_a11+','+text_a12+'],['+text_a21+','+text_a22+']])';
  return [code, Blockly.JavaScript.ORDER_NONE];
};
Blockly.JavaScript['mat_3D'] = function(block) {
  var text_a11 = block.getFieldValue('a11');
  var text_a12 = block.getFieldValue('a12');
  var text_a13 = block.getFieldValue('a13');
  var text_a21 = block.getFieldValue('a21');
  var text_a22 = block.getFieldValue('a22');
  var text_a23 = block.getFieldValue('a23');
  var text_a31 = block.getFieldValue('a31');
  var text_a32 = block.getFieldValue('a32');
  var text_a33 = block.getFieldValue('a33');
  var code = 'Matrix.create([['+text_a11+','+text_a12+','+text_a13+'],['+text_a21+','+text_a22+','+text_a23+'],['+text_a31+','+text_a32+','+text_a33+']])';
  return [code, Blockly.JavaScript.ORDER_NONE];
};


Blockly.JavaScript['mat_diag'] = function(block) {
  var text_a11 = block.getFieldValue('a11');
  var text_a22 = block.getFieldValue('a22');
  var code = 'Matrix.Diagonal(['+text_a11+','+text_a22+'])';
  return [code, Blockly.JavaScript.ORDER_NONE];
};


Blockly.JavaScript['mat_id'] = function(block) {
  var code = 'Matrix.I(2)';
  return [code, Blockly.JavaScript.ORDER_NONE];
};
Blockly.JavaScript['mat_id3'] = function(block) {
  var code = 'Matrix.I(3)';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['mat_alea'] = function(block) {
  var code = 'Matrix.Random(2,2)';
  return [code, Blockly.JavaScript.ORDER_NONE];
};
Blockly.JavaScript['mat_alea3'] = function(block) {
  var code = 'Matrix.Random(3,3)';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['mat_nulle'] = function(block) {
  var code = 'Matrix.Zero(2,2)';
  return [code, Blockly.JavaScript.ORDER_NONE];
};
Blockly.JavaScript['mat_nulle3'] = function(block) {
  var code = 'Matrix.Zero(3,3)';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['mat_rotation'] = function(block) {
  var angle_angle = block.getFieldValue('angle');
  var code = 'Matrix.Rotation(Math.PI*' + angle_angle + "/180)";
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['mat_colonne1'] = function(block) {
  var value_name = Blockly.JavaScript.valueToCode(block, 'NAME', Blockly.JavaScript.ORDER_ATOMIC);
  var code = value_name + '.col(1)';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['mat_colonne2'] = function(block) {
  var value_name = Blockly.JavaScript.valueToCode(block, 'NAME', Blockly.JavaScript.ORDER_ATOMIC);
  var code = value_name + '.col(2)';
  return [code, Blockly.JavaScript.ORDER_NONE];
};
Blockly.JavaScript['mat_colonne3'] = function(block) {
  var value_name = Blockly.JavaScript.valueToCode(block, 'NAME', Blockly.JavaScript.ORDER_ATOMIC);
  var code = value_name + '.col(3)';
  return [code, Blockly.JavaScript.ORDER_NONE];
};
Blockly.JavaScript['mat_diagonal'] = function(block) {
  var value_name = Blockly.JavaScript.valueToCode(block, 'NAME', Blockly.JavaScript.ORDER_ATOMIC);
  var code = value_name + '.diagonal()';
  return [code, Blockly.JavaScript.ORDER_NONE];
};


Blockly.JavaScript['mat_det'] = function(block) {
  var value_matr = Blockly.JavaScript.valueToCode(block, 'matr', Blockly.JavaScript.ORDER_ATOMIC);
  var code = value_matr + '.determinant()';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['mat_inv'] = function(block) {
  var value_matr = Blockly.JavaScript.valueToCode(block, 'matr', Blockly.JavaScript.ORDER_ATOMIC);
  var code = value_matr + '.inverse()';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['mat_mult'] = function(block) {
  var variable_lui = Blockly.JavaScript.variableDB_.getName(block.getFieldValue('lui'), Blockly.Variables.NAME_TYPE);
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = variable_lui + '.multiply(' + value_autre + ')';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['mat_arrondi'] = function(block) {
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = value_autre + '.round()';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['mat_trace'] = function(block) {
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = value_autre + '.trace()';
  return [code, Blockly.JavaScript.ORDER_NONE];
};

Blockly.JavaScript['mat_transpose'] = function(block) {
  var value_autre = Blockly.JavaScript.valueToCode(block, 'autre', Blockly.JavaScript.ORDER_ATOMIC);
  var code = value_autre + '.transpose()';
  return [code, Blockly.JavaScript.ORDER_NONE];
};




Blockly.JavaScript['big_aff'] = function(block) {
  var value_var = Blockly.JavaScript.valueToCode(block, 'VAR', Blockly.JavaScript.ORDER_ATOMIC);
  var code = 'document.getElementById("sortieNum").value += "\\n" + ' + value_var + ";\n";
  return code;
};

Blockly.JavaScript['big_efface'] = function(block) {
  var code = 'document.getElementById("sortieNum").value = "";\n';
  return code;
};
